# cuML Notebooks
## Intro
These notebooks provide examples of how to use cuML.  These notebooks are designed to be self-contained with the `runtime` version of the [RAPIDS Docker Container](https://hub.docker.com/r/rapidsai/rapidsai/) and [RAPIDS Nightly Docker Containers](https://hub.docker.com/r/rapidsai/rapidsai-nightly) and can run on air-gapped systems.  You can quickly get this container using the install guide from the [RAPIDS.ai Getting Started page](https://rapids.ai/start.html#get-rapids)

## Getting started notebooks
For a good overview of how cuML works, see [the introductory notebook
on estimators](../docs/source/estimator_intro.ipynb) in the
documentation tree.

## Additional notebooks
Notebook Title | Status | Description
--- | --- | --- 
[ARIMA Demo](arima_demo.ipynb) | Working | 
[Forest Inference Demo](forest_inference_demo.ipynb) | Working |
[KMeans Demo](kmeans_demo.ipynb) | Working |
[KMeans Multi-Node Multi-GPU Demo](kmeans_mnmg_demo.ipynb) | Working |
[Linear Regression Demo](linear_regression_demo.ipynb) | Working |
[Nearest Neighbors Demo](nearest_neighbors_demo.ipynb) | Working |
[Random Forest Demo](random_forest_demo.ipynb) | Working |
[Random Forest Multi-Node Multi-GPU Demo](random_forest_mnmg_demo.ipynb) | Working |

## For more details
Many more examples can be found in the [RAPIDS Notebooks
Contrib](https://github.com/rapidsai/notebooks-contrib) repository,
which contains community-maintained notebooks.
